diff --git a/src/cdogs/automap.c b/src/cdogs/automap.c
index 932ca2658..8af1e189a 100644
--- a/src/cdogs/automap.c
+++ b/src/cdogs/automap.c
@@ -238,7 +238,8 @@ void DisplayAutoMap(int showAll)
 		for (i = 0; i < MAP_FACTOR; i++) {
 			for (x = 0; x < XMAX; x++)
 			{
-				if (Map(x, y).isVisited || showAll)
+				if (!(Map(x, y).flags & MAPTILE_IS_NOTHING) &&
+					(Map(x, y).isVisited || showAll))
 				{
 					int tileFlags = Map(x, y).flags;
 					for (j = 0; j < MAP_FACTOR; j++)
@@ -310,6 +311,4 @@ void DisplayAutoMap(int showAll)
 
 	DisplayExit();
 	DisplaySummary();
-
-	BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 }
diff --git a/src/cdogs/game.c b/src/cdogs/game.c
index 9a96e5de2..147b3e27c 100644
--- a/src/cdogs/game.c
+++ b/src/cdogs/game.c
@@ -434,6 +434,7 @@ int HandleKey(int *done, int cmd)
 			if (!hasDisplayedAutomap)
 			{
 				DisplayAutoMap(0);
+				BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 				hasDisplayedAutomap = 1;
 			}
 			SDL_Delay(10);
diff --git a/src/cdogs/map.c b/src/cdogs/map.c
index 91a05fbc8..d696d1df7 100644
--- a/src/cdogs/map.c
+++ b/src/cdogs/map.c
@@ -458,7 +458,8 @@ static void FixMap(int floor, int room, int wall)
 				break;
 
 			case MAP_NOTHING:
-				Map(x, y).flags = MAPTILE_NO_WALK | MAPTILE_NO_SEE;
+				Map(x, y).flags =
+					MAPTILE_NO_WALK | MAPTILE_NO_SEE | MAPTILE_IS_NOTHING;
 				break;
 			}
 		}
diff --git a/src/cdogs/map.h b/src/cdogs/map.h
index 655f353a8..0b98940b1 100644
--- a/src/cdogs/map.h
+++ b/src/cdogs/map.h
@@ -69,12 +69,13 @@ typedef enum
 	MAPTILE_NO_SHOOT		= 0x004,
 	MAPTILE_IS_SHADOW		= 0x008,
 	MAPTILE_IS_WALL			= 0x010,
-	MAPTILE_OFFSET_PIC		= 0x020,
-	MAPTILE_IS_SHADOW2		= 0x040,
-	MAPTILE_TILE_TRIGGER	= 0x080,
+	MAPTILE_IS_NOTHING		= 0x020,
+	MAPTILE_OFFSET_PIC		= 0x040,
+	MAPTILE_IS_SHADOW2		= 0x080,
+	MAPTILE_TILE_TRIGGER	= 0x100,
 // These constants are used internally in draw, it is never set in the map
-	MAPTILE_DELAY_DRAW		= 0x100,
-	MAPTILE_OUT_OF_SIGHT	= 0x200
+	MAPTILE_DELAY_DRAW		= 0x200,
+	MAPTILE_OUT_OF_SIGHT	= 0x400
 } MapTileFlags;
 
 #define KIND_CHARACTER      0
diff --git a/src/cdogsed.c b/src/cdogsed.c
index 98b45ac2c..3643a890e 100644
--- a/src/cdogsed.c
+++ b/src/cdogsed.c
@@ -709,7 +709,7 @@ static void DisplayMission(int idx, int xc, int yc, int y)
 	}
 }
 
-void Display(int idx, int xc, int yc, int key)
+static void Display(int mission, int xc, int yc, int willDisplayAutomap)
 {
 	char s[128];
 	int y = 5;
@@ -728,9 +728,6 @@ void Display(int idx, int xc, int yc, int key)
 		}
 	}
 
-	sprintf(s, "Key: 0x%x", key);
-	CDogsTextStringAt(270, 190, s);
-
 	DrawEditableTextWithEmptyHint(
 		Vec2iNew(25, y),
 		gCampaign.Setting.title, "(Campaign title)",
@@ -745,7 +742,7 @@ void Display(int idx, int xc, int yc, int key)
 
 	if (currentMission)
 	{
-		DisplayMission(idx, xc, yc, y);
+		DisplayMission(mission, xc, yc, y);
 	}
 	else if (gCampaign.Setting.missionCount)
 	{
@@ -841,7 +838,14 @@ void Display(int idx, int xc, int yc, int key)
 		break;
 	}
 
-	MouseDraw(&gInputDevices.mouse);
+	if (willDisplayAutomap)
+	{
+		DisplayAutoMap(1);
+	}
+	else
+	{
+		MouseDraw(&gInputDevices.mouse);
+	}
 	BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 }
 
@@ -1512,7 +1516,7 @@ static void HandleInput(
 	int c, int m,
 	int *xc, int *yc, int *xcOld, int *ycOld,
 	int *mission, struct Mission *scrap,
-	int *done)
+	int *willDisplayAutomap, int *done)
 {
 	int mouseTag;
 	if (m && MouseTryGetRectTag(&gInputDevices.mouse, &mouseTag))
@@ -1588,12 +1592,7 @@ static void HandleInput(
 			break;
 
 		case 'm':
-			Setup(*mission, 0);
-			SetupMap();
-			DisplayAutoMap(1);
-			GetKey(&gInputDevices);
-			KillAllObjects();
-			FreeTriggersAndWatches();
+			*willDisplayAutomap = 1;
 			break;
 
 		case 'e':
@@ -1750,13 +1749,22 @@ static void EditCampaign(void)
 	SDL_EnableKeyRepeat(0, 0);
 	while (!done)
 	{
+		int willDisplayAutomap = 0;
 		int c, m;
 		InputPoll(&gInputDevices, SDL_GetTicks());
 		c = KeyGetPressed(&gInputDevices.keyboard);
 		m = MouseGetPressed(&gInputDevices.mouse);
 
-		HandleInput(c, m, &xc, &yc, &xcOld, &ycOld, &mission, &scrap, &done);
-		Display(mission, xc, yc, c);
+		HandleInput(
+			c, m,
+			&xc, &yc, &xcOld, &ycOld,
+			&mission, &scrap,
+			&willDisplayAutomap, &done);
+		Display(mission, xc, yc, willDisplayAutomap);
+		if (willDisplayAutomap)
+		{
+			GetKey(&gInputDevices);
+		}
 		SDL_Delay(10);
 	}
 }
